Index: lemon/adaptors.h
===================================================================
--- lemon/adaptors.h	(revision 606)
+++ lemon/adaptors.h	(revision 626)
@@ -2193,4 +2193,7 @@
     typedef typename ItemSetTraits<DGR, Edge>::ItemNotifier EdgeNotifier;
     EdgeNotifier& notifier(Edge) const { return _digraph->notifier(Edge()); }
+    
+    typedef EdgeNotifier ArcNotifier;
+    ArcNotifier& notifier(Arc) const { return _digraph->notifier(Edge()); }
 
   protected:
Index: lemon/cbc.cc
===================================================================
--- lemon/cbc.cc	(revision 623)
+++ lemon/cbc.cc	(revision 614)
@@ -56,13 +56,10 @@
     _osi_solver = 0;
     _cbc_model = 0;
-    messageLevel(MESSAGE_NOTHING);
   }
 
   CbcMip::CbcMip(const CbcMip& other) {
     _prob = new CoinModel(*other._prob);
-    _prob->setProblemName("LEMON");
     _osi_solver = 0;
     _cbc_model = 0;
-    messageLevel(MESSAGE_NOTHING);
   }
 
@@ -274,6 +271,22 @@
     _cbc_model= new CbcModel(*_osi_solver);
 
-    _osi_solver->messageHandler()->setLogLevel(_message_level);
-    _cbc_model->setLogLevel(_message_level);
+    switch (_message_level) {
+    case MESSAGE_NO_OUTPUT:
+      _osi_solver->messageHandler()->setLogLevel(0);
+      _cbc_model->setLogLevel(0);
+      break;
+    case MESSAGE_ERROR_MESSAGE:
+      _osi_solver->messageHandler()->setLogLevel(1);
+      _cbc_model->setLogLevel(1);
+      break;
+    case MESSAGE_NORMAL_OUTPUT:
+      _osi_solver->messageHandler()->setLogLevel(2);
+      _cbc_model->setLogLevel(2);
+      break;
+    case MESSAGE_FULL_OUTPUT:
+      _osi_solver->messageHandler()->setLogLevel(3);
+      _cbc_model->setLogLevel(3);
+      break;
+    }
 
     _cbc_model->initialSolve();
@@ -441,22 +454,6 @@
   }
 
-  void CbcMip::_messageLevel(MessageLevel level) {
-    switch (level) {
-    case MESSAGE_NOTHING:
-      _message_level = 0;
-      break;
-    case MESSAGE_ERROR:
-      _message_level = 1;
-      break;
-    case MESSAGE_WARNING:
-      _message_level = 1;
-      break;
-    case MESSAGE_NORMAL:
-      _message_level = 2;
-      break;
-    case MESSAGE_VERBOSE:
-      _message_level = 3;
-      break;
-    }
+  void CbcMip::messageLevel(MessageLevel m) {
+    _message_level = m;
   }
 
Index: lemon/cbc.h
===================================================================
--- lemon/cbc.h	(revision 623)
+++ lemon/cbc.h	(revision 614)
@@ -116,10 +116,31 @@
     virtual void _clear();
 
-    virtual void _messageLevel(MessageLevel level);
-    void _applyMessageLevel();
+  public:
 
-    int _message_level;
+    ///Enum for \c messageLevel() parameter
+    enum MessageLevel {
+      /// no output (default value)
+      MESSAGE_NO_OUTPUT = 0,
+      /// error messages only
+      MESSAGE_ERROR_MESSAGE = 1,
+      /// normal output
+      MESSAGE_NORMAL_OUTPUT = 2,
+      /// full output (includes informational messages)
+      MESSAGE_FULL_OUTPUT = 3
+    };
 
-    
+  private:
+
+    MessageLevel _message_level;
+
+  public:
+
+    ///Set the verbosity of the messages
+
+    ///Set the verbosity of the messages
+    ///
+    ///\param m is the level of the messages output by the solver routines.
+    void messageLevel(MessageLevel m);
+
 
   };
Index: lemon/clp.cc
===================================================================
--- lemon/clp.cc	(revision 623)
+++ lemon/clp.cc	(revision 587)
@@ -25,5 +25,5 @@
     _prob = new ClpSimplex();
     _init_temporals();
-    messageLevel(MESSAGE_NOTHING);
+    messageLevel(MESSAGE_NO_OUTPUT);
   }
 
@@ -33,5 +33,5 @@
     cols = other.cols;
     _init_temporals();
-    messageLevel(MESSAGE_NOTHING);
+    messageLevel(MESSAGE_NO_OUTPUT);
   }
 
@@ -431,22 +431,6 @@
   }
 
-  void ClpLp::_messageLevel(MessageLevel level) {
-    switch (level) {
-    case MESSAGE_NOTHING:
-      _prob->setLogLevel(0);
-      break;
-    case MESSAGE_ERROR:
-      _prob->setLogLevel(1);
-      break;
-    case MESSAGE_WARNING:
-      _prob->setLogLevel(2);
-      break;
-    case MESSAGE_NORMAL:
-      _prob->setLogLevel(3);
-      break;
-    case MESSAGE_VERBOSE:
-      _prob->setLogLevel(4);
-      break;
-    }
+  void ClpLp::messageLevel(MessageLevel m) {
+    _prob->setLogLevel(static_cast<int>(m));
   }
 
Index: lemon/clp.h
===================================================================
--- lemon/clp.h	(revision 623)
+++ lemon/clp.h	(revision 587)
@@ -137,6 +137,4 @@
     virtual void _clear();
 
-    virtual void _messageLevel(MessageLevel);
-    
   public:
 
@@ -156,4 +154,24 @@
     int clpCol(Col c) const { return cols(id(c)); }
 
+    ///Enum for \c messageLevel() parameter
+    enum MessageLevel {
+      /// no output (default value)
+      MESSAGE_NO_OUTPUT = 0,
+      /// print final solution
+      MESSAGE_FINAL_SOLUTION = 1,
+      /// print factorization
+      MESSAGE_FACTORIZATION = 2,
+      /// normal output
+      MESSAGE_NORMAL_OUTPUT = 3,
+      /// verbose output
+      MESSAGE_VERBOSE_OUTPUT = 4
+    };
+    ///Set the verbosity of the messages
+
+    ///Set the verbosity of the messages
+    ///
+    ///\param m is the level of the messages output by the solver routines.
+    void messageLevel(MessageLevel m);
+
   };
 
Index: lemon/concepts/graph_components.h
===================================================================
--- lemon/concepts/graph_components.h	(revision 606)
+++ lemon/concepts/graph_components.h	(revision 626)
@@ -32,15 +32,14 @@
   namespace concepts {
 
-    /// \brief Skeleton class for graph Node and Arc types
-    ///
-    /// This class describes the interface of Node and Arc (and Edge
-    /// in undirected graphs) subtypes of graph types.
+    /// \brief Concept class for \c Node, \c Arc and \c Edge types.
+    ///
+    /// This class describes the concept of \c Node, \c Arc and \c Edge
+    /// subtypes of digraph and graph types.
     ///
     /// \note This class is a template class so that we can use it to
-    /// create graph skeleton classes. The reason for this is than Node
-    /// and Arc types should \em not derive from the same base class.
-    /// For Node you should instantiate it with character 'n' and for Arc
-    /// with 'a'.
-
+    /// create graph skeleton classes. The reason for this is that \c Node
+    /// and \c Arc (or \c Edge) types should \e not derive from the same 
+    /// base class. For \c Node you should instantiate it with character
+    /// \c 'n', for \c Arc with \c 'a' and for \c Edge with \c 'e'.
 #ifndef DOXYGEN
     template <char sel = '0'>
@@ -50,43 +49,47 @@
       /// \brief Default constructor.
       ///
+      /// Default constructor.
       /// \warning The default constructor is not required to set
       /// the item to some well-defined value. So you should consider it
       /// as uninitialized.
       GraphItem() {}
+
       /// \brief Copy constructor.
       ///
       /// Copy constructor.
-      ///
       GraphItem(const GraphItem &) {}
-      /// \brief Invalid constructor \& conversion.
-      ///
-      /// This constructor initializes the item to be invalid.
+
+      /// \brief Constructor for conversion from \c INVALID.
+      ///
+      /// Constructor for conversion from \c INVALID.
+      /// It initializes the item to be invalid.
       /// \sa Invalid for more details.
       GraphItem(Invalid) {}
-      /// \brief Assign operator for nodes.
-      ///
-      /// The nodes are assignable.
-      ///
-      GraphItem& operator=(GraphItem const&) { return *this; }
+
+      /// \brief Assignment operator.
+      ///
+      /// Assignment operator for the item.
+      GraphItem& operator=(const GraphItem&) { return *this; }
+
       /// \brief Equality operator.
       ///
-      /// Two iterators are equal if and only if they represents the
-      /// same node in the graph or both are invalid.
-      bool operator==(GraphItem) const { return false; }
+      /// Equality operator.
+      bool operator==(const GraphItem&) const { return false; }
+
       /// \brief Inequality operator.
       ///
-      /// \sa operator==(const Node& n)
-      ///
-      bool operator!=(GraphItem) const { return false; }
-
-      /// \brief Artificial ordering operator.
-      ///
-      /// To allow the use of graph descriptors as key type in std::map or
-      /// similar associative container we require this.
+      /// Inequality operator.
+      bool operator!=(const GraphItem&) const { return false; }
+
+      /// \brief Ordering operator.
+      ///
+      /// This operator defines an ordering of the items.
+      /// It makes possible to use graph item types as key types in 
+      /// associative containers (e.g. \c std::map).
       ///
       /// \note This operator only have to define some strict ordering of
       /// the items; this order has nothing to do with the iteration
       /// ordering of the items.
-      bool operator<(GraphItem) const { return false; }
+      bool operator<(const GraphItem&) const { return false; }
 
       template<typename _GraphItem>
@@ -100,5 +103,4 @@
 
           bool b;
-          //          b = (ia == ib) && (ia != ib) && (ia < ib);
           b = (ia == ib) && (ia != ib);
           b = (ia == INVALID) && (ib != INVALID);
@@ -111,11 +113,10 @@
     };
 
-    /// \brief An empty base directed graph class.
-    ///
-    /// This class provides the minimal set of features needed for a
-    /// directed graph structure. All digraph concepts have to
-    /// conform to this base directed graph. It just provides types
-    /// for nodes and arcs and functions to get the source and the
-    /// target of the arcs.
+    /// \brief Base skeleton class for directed graphs.
+    ///
+    /// This class describes the base interface of directed graph types.
+    /// All digraph %concepts have to conform to this class.
+    /// It just provides types for nodes and arcs and functions 
+    /// to get the source and the target nodes of arcs.
     class BaseDigraphComponent {
     public:
@@ -125,29 +126,25 @@
       /// \brief Node class of the digraph.
       ///
-      /// This class represents the Nodes of the digraph.
-      ///
+      /// This class represents the nodes of the digraph.
       typedef GraphItem<'n'> Node;
 
       /// \brief Arc class of the digraph.
       ///
-      /// This class represents the Arcs of the digraph.
-      ///
-      typedef GraphItem<'e'> Arc;
-
-      /// \brief Gives back the target node of an arc.
-      ///
-      /// Gives back the target node of an arc.
-      ///
-      Node target(const Arc&) const { return INVALID;}
-
-      /// \brief Gives back the source node of an arc.
-      ///
-      /// Gives back the source node of an arc.
-      ///
-      Node source(const Arc&) const { return INVALID;}
-
-      /// \brief Gives back the opposite node on the given arc.
-      ///
-      /// Gives back the opposite node on the given arc.
+      /// This class represents the arcs of the digraph.
+      typedef GraphItem<'a'> Arc;
+
+      /// \brief Return the source node of an arc.
+      ///
+      /// This function returns the source node of an arc.
+      Node source(const Arc&) const { return INVALID; }
+
+      /// \brief Return the target node of an arc.
+      ///
+      /// This function returns the target node of an arc.
+      Node target(const Arc&) const { return INVALID; }
+
+      /// \brief Return the opposite node on the given arc.
+      ///
+      /// This function returns the opposite node on the given arc.
       Node oppositeNode(const Node&, const Arc&) const {
         return INVALID;
@@ -175,50 +172,55 @@
     };
 
-    /// \brief An empty base undirected graph class.
-    ///
-    /// This class provides the minimal set of features needed for an
-    /// undirected graph structure. All undirected graph concepts have
-    /// to conform to this base graph. It just provides types for
-    /// nodes, arcs and edges and functions to get the
-    /// source and the target of the arcs and edges,
-    /// conversion from arcs to edges and function to get
-    /// both direction of the edges.
+    /// \brief Base skeleton class for undirected graphs.
+    ///
+    /// This class describes the base interface of undirected graph types.
+    /// All graph %concepts have to conform to this class.
+    /// It extends the interface of \ref BaseDigraphComponent with an
+    /// \c Edge type and functions to get the end nodes of edges,
+    /// to convert from arcs to edges and to get both direction of edges.
     class BaseGraphComponent : public BaseDigraphComponent {
     public:
       typedef BaseDigraphComponent::Node Node;
       typedef BaseDigraphComponent::Arc Arc;
-      /// \brief Undirected arc class of the graph.
-      ///
-      /// This class represents the edges of the graph.
-      /// The undirected graphs can be used as a directed graph which
-      /// for each arc contains the opposite arc too so the graph is
-      /// bidirected. The edge represents two opposite
-      /// directed arcs.
-      class Edge : public GraphItem<'u'> {
+
+      /// \brief Undirected edge class of the graph.
+      ///
+      /// This class represents the undirected edges of the graph.
+      /// Undirected graphs can be used as directed graphs, each edge is
+      /// represented by two opposite directed arcs.
+      class Edge : public GraphItem<'e'> {
       public:
-        typedef GraphItem<'u'> Parent;
+        typedef GraphItem<'e'> Parent;
+
         /// \brief Default constructor.
         ///
+        /// Default constructor.
         /// \warning The default constructor is not required to set
         /// the item to some well-defined value. So you should consider it
         /// as uninitialized.
         Edge() {}
+
         /// \brief Copy constructor.
         ///
         /// Copy constructor.
-        ///
         Edge(const Edge &) : Parent() {}
-        /// \brief Invalid constructor \& conversion.
-        ///
-        /// This constructor initializes the item to be invalid.
+
+        /// \brief Constructor for conversion from \c INVALID.
+        ///
+        /// Constructor for conversion from \c INVALID.
+        /// It initializes the item to be invalid.
         /// \sa Invalid for more details.
         Edge(Invalid) {}
-        /// \brief Converter from arc to edge.
-        ///
+
+        /// \brief Constructor for conversion from an arc.
+        ///
+        /// Constructor for conversion from an arc.
         /// Besides the core graph item functionality each arc should
         /// be convertible to the represented edge.
         Edge(const Arc&) {}
-        /// \brief Assign arc to edge.
-        ///
+
+        /// \brief Assign an arc to an edge.
+        ///
+        /// This function assigns an arc to an edge.
         /// Besides the core graph item functionality each arc should
         /// be convertible to the represented edge.
@@ -226,5 +228,27 @@
       };
 
-      /// \brief Returns the direction of the arc.
+      /// \brief Return one end node of an edge.
+      ///
+      /// This function returns one end node of an edge.
+      Node u(const Edge&) const { return INVALID; }
+
+      /// \brief Return the other end node of an edge.
+      ///
+      /// This function returns the other end node of an edge.
+      Node v(const Edge&) const { return INVALID; }
+
+      /// \brief Return a directed arc related to an edge.
+      ///
+      /// This function returns a directed arc from its direction and the
+      /// represented edge.
+      Arc direct(const Edge&, bool) const { return INVALID; }
+
+      /// \brief Return a directed arc related to an edge.
+      ///
+      /// This function returns a directed arc from its source node and the
+      /// represented edge.
+      Arc direct(const Edge&, const Node&) const { return INVALID; }
+
+      /// \brief Return the direction of the arc.
       ///
       /// Returns the direction of the arc. Each arc represents an
@@ -233,31 +257,9 @@
       bool direction(const Arc&) const { return true; }
 
-      /// \brief Returns the directed arc.
-      ///
-      /// Returns the directed arc from its direction and the
-      /// represented edge.
-      Arc direct(const Edge&, bool) const { return INVALID;}
-
-      /// \brief Returns the directed arc.
-      ///
-      /// Returns the directed arc from its source and the
-      /// represented edge.
-      Arc direct(const Edge&, const Node&) const { return INVALID;}
-
-      /// \brief Returns the opposite arc.
-      ///
-      /// Returns the opposite arc. It is the arc representing the
-      /// same edge and has opposite direction.
-      Arc oppositeArc(const Arc&) const { return INVALID;}
-
-      /// \brief Gives back one ending of an edge.
-      ///
-      /// Gives back one ending of an edge.
-      Node u(const Edge&) const { return INVALID;}
-
-      /// \brief Gives back the other ending of an edge.
-      ///
-      /// Gives back the other ending of an edge.
-      Node v(const Edge&) const { return INVALID;}
+      /// \brief Return the opposite arc.
+      ///
+      /// This function returns the opposite arc, i.e. the arc representing
+      /// the same edge and has opposite direction.
+      Arc oppositeArc(const Arc&) const { return INVALID; }
 
       template <typename _Graph>
@@ -269,5 +271,5 @@
         void constraints() {
           checkConcept<BaseDigraphComponent, _Graph>();
-          checkConcept<GraphItem<'u'>, Edge>();
+          checkConcept<GraphItem<'e'>, Edge>();
           {
             Node n;
@@ -277,4 +279,5 @@
             n = graph.v(ue);
             e = graph.direct(ue, true);
+            e = graph.direct(ue, false);
             e = graph.direct(ue, n);
             e = graph.oppositeArc(e);
@@ -290,10 +293,10 @@
     };
 
-    /// \brief An empty idable base digraph class.
-    ///
-    /// This class provides beside the core digraph features
-    /// core id functions for the digraph structure.
-    /// The most of the base digraphs should conform to this concept.
-    /// The id's are unique and immutable.
+    /// \brief Skeleton class for \e idable directed graphs.
+    ///
+    /// This class describes the interface of \e idable directed graphs.
+    /// It extends \ref BaseDigraphComponent with the core ID functions.
+    /// The ids of the items must be unique and immutable.
+    /// This concept is part of the Digraph concept.
     template <typename BAS = BaseDigraphComponent>
     class IDableDigraphComponent : public BAS {
@@ -304,43 +307,41 @@
       typedef typename Base::Arc Arc;
 
-      /// \brief Gives back an unique integer id for the Node.
-      ///
-      /// Gives back an unique integer id for the Node.
-      ///
-      int id(const Node&) const { return -1;}
-
-      /// \brief Gives back the node by the unique id.
-      ///
-      /// Gives back the node by the unique id.
-      /// If the digraph does not contain node with the given id
-      /// then the result of the function is undetermined.
-      Node nodeFromId(int) const { return INVALID;}
-
-      /// \brief Gives back an unique integer id for the Arc.
-      ///
-      /// Gives back an unique integer id for the Arc.
-      ///
-      int id(const Arc&) const { return -1;}
-
-      /// \brief Gives back the arc by the unique id.
-      ///
-      /// Gives back the arc by the unique id.
-      /// If the digraph does not contain arc with the given id
-      /// then the result of the function is undetermined.
-      Arc arcFromId(int) const { return INVALID;}
-
-      /// \brief Gives back an integer greater or equal to the maximum
-      /// Node id.
-      ///
-      /// Gives back an integer greater or equal to the maximum Node
-      /// id.
-      int maxNodeId() const { return -1;}
-
-      /// \brief Gives back an integer greater or equal to the maximum
-      /// Arc id.
-      ///
-      /// Gives back an integer greater or equal to the maximum Arc
-      /// id.
-      int maxArcId() const { return -1;}
+      /// \brief Return a unique integer id for the given node.
+      ///
+      /// This function returns a unique integer id for the given node.
+      int id(const Node&) const { return -1; }
+
+      /// \brief Return the node by its unique id.
+      ///
+      /// This function returns the node by its unique id.
+      /// If the digraph does not contain a node with the given id,
+      /// then the result of the function is undefined.
+      Node nodeFromId(int) const { return INVALID; }
+
+      /// \brief Return a unique integer id for the given arc.
+      ///
+      /// This function returns a unique integer id for the given arc.
+      int id(const Arc&) const { return -1; }
+
+      /// \brief Return the arc by its unique id.
+      ///
+      /// This function returns the arc by its unique id.
+      /// If the digraph does not contain an arc with the given id,
+      /// then the result of the function is undefined.
+      Arc arcFromId(int) const { return INVALID; }
+
+      /// \brief Return an integer greater or equal to the maximum
+      /// node id.
+      ///
+      /// This function returns an integer greater or equal to the
+      /// maximum node id.
+      int maxNodeId() const { return -1; }
+
+      /// \brief Return an integer greater or equal to the maximum
+      /// arc id.
+      ///
+      /// This function returns an integer greater or equal to the
+      /// maximum arc id.
+      int maxArcId() const { return -1; }
 
       template <typename _Digraph>
@@ -368,10 +369,11 @@
     };
 
-    /// \brief An empty idable base undirected graph class.
-    ///
-    /// This class provides beside the core undirected graph features
-    /// core id functions for the undirected graph structure.  The
-    /// most of the base undirected graphs should conform to this
-    /// concept.  The id's are unique and immutable.
+    /// \brief Skeleton class for \e idable undirected graphs.
+    ///
+    /// This class describes the interface of \e idable undirected
+    /// graphs. It extends \ref IDableDigraphComponent with the core ID
+    /// functions of undirected graphs.
+    /// The ids of the items must be unique and immutable.
+    /// This concept is part of the Graph concept.
     template <typename BAS = BaseGraphComponent>
     class IDableGraphComponent : public IDableDigraphComponent<BAS> {
@@ -383,23 +385,22 @@
       using IDableDigraphComponent<Base>::id;
 
-      /// \brief Gives back an unique integer id for the Edge.
-      ///
-      /// Gives back an unique integer id for the Edge.
-      ///
-      int id(const Edge&) const { return -1;}
-
-      /// \brief Gives back the edge by the unique id.
-      ///
-      /// Gives back the edge by the unique id.  If the
-      /// graph does not contain arc with the given id then the
-      /// result of the function is undetermined.
-      Edge edgeFromId(int) const { return INVALID;}
-
-      /// \brief Gives back an integer greater or equal to the maximum
-      /// Edge id.
-      ///
-      /// Gives back an integer greater or equal to the maximum Edge
-      /// id.
-      int maxEdgeId() const { return -1;}
+      /// \brief Return a unique integer id for the given edge.
+      ///
+      /// This function returns a unique integer id for the given edge.
+      int id(const Edge&) const { return -1; }
+
+      /// \brief Return the edge by its unique id.
+      ///
+      /// This function returns the edge by its unique id.
+      /// If the graph does not contain an edge with the given id,
+      /// then the result of the function is undefined.
+      Edge edgeFromId(int) const { return INVALID; }
+
+      /// \brief Return an integer greater or equal to the maximum
+      /// edge id.
+      ///
+      /// This function returns an integer greater or equal to the
+      /// maximum edge id.
+      int maxEdgeId() const { return -1; }
 
       template <typename _Graph>
@@ -407,5 +408,4 @@
 
         void constraints() {
-          checkConcept<Base, _Graph >();
           checkConcept<IDableDigraphComponent<Base>, _Graph >();
           typename _Graph::Edge edge;
@@ -421,8 +421,8 @@
     };
 
-    /// \brief Skeleton class for graph NodeIt and ArcIt
-    ///
-    /// Skeleton class for graph NodeIt and ArcIt.
-    ///
+    /// \brief Concept class for \c NodeIt, \c ArcIt and \c EdgeIt types.
+    ///
+    /// This class describes the concept of \c NodeIt, \c ArcIt and 
+    /// \c EdgeIt subtypes of digraph and graph types.
     template <typename GR, typename Item>
     class GraphItemIt : public Item {
@@ -430,41 +430,50 @@
       /// \brief Default constructor.
       ///
-      /// @warning The default constructor sets the iterator
-      /// to an undefined value.
+      /// Default constructor.
+      /// \warning The default constructor is not required to set
+      /// the iterator to some well-defined value. So you should consider it
+      /// as uninitialized.
       GraphItemIt() {}
+
       /// \brief Copy constructor.
       ///
       /// Copy constructor.
-      ///
-      GraphItemIt(const GraphItemIt& ) {}
-      /// \brief Sets the iterator to the first item.
-      ///
-      /// Sets the iterator to the first item of \c the graph.
-      ///
+      GraphItemIt(const GraphItemIt& it) : Item(it) {}
+
+      /// \brief Constructor that sets the iterator to the first item.
+      ///
+      /// Constructor that sets the iterator to the first item.
       explicit GraphItemIt(const GR&) {}
-      /// \brief Invalid constructor \& conversion.
-      ///
-      /// This constructor initializes the item to be invalid.
+
+      /// \brief Constructor for conversion from \c INVALID.
+      ///
+      /// Constructor for conversion from \c INVALID.
+      /// It initializes the iterator to be invalid.
       /// \sa Invalid for more details.
       GraphItemIt(Invalid) {}
-      /// \brief Assign operator for items.
-      ///
-      /// The items are assignable.
-      ///
+
+      /// \brief Assignment operator.
+      ///
+      /// Assignment operator for the iterator.
       GraphItemIt& operator=(const GraphItemIt&) { return *this; }
-      /// \brief Next item.
-      ///
-      /// Assign the iterator to the next item.
-      ///
+
+      /// \brief Increment the iterator.
+      ///
+      /// This operator increments the iterator, i.e. assigns it to the
+      /// next item.
       GraphItemIt& operator++() { return *this; }
+ 
       /// \brief Equality operator
       ///
+      /// Equality operator.
       /// Two iterators are equal if and only if they point to the
       /// same object or both are invalid.
       bool operator==(const GraphItemIt&) const { return true;}
+
       /// \brief Inequality operator
       ///
-      /// \sa operator==(Node n)
-      ///
+      /// Inequality operator.
+      /// Two iterators are equal if and only if they point to the
+      /// same object or both are invalid.
       bool operator!=(const GraphItemIt&) const { return true;}
 
@@ -472,6 +481,9 @@
       struct Constraints {
         void constraints() {
+          checkConcept<GraphItem<>, _GraphItemIt>();
           _GraphItemIt it1(g);
           _GraphItemIt it2;
+          _GraphItemIt it3 = it1;
+          _GraphItemIt it4 = INVALID;
 
           it2 = ++it1;
@@ -482,14 +494,18 @@
           bi = it2;
         }
-        GR& g;
-      };
-    };
-
-    /// \brief Skeleton class for graph InArcIt and OutArcIt
-    ///
-    /// \note Because InArcIt and OutArcIt may not inherit from the same
-    /// base class, the \c sel is a additional template parameter (selector).
-    /// For InArcIt you should instantiate it with character 'i' and for
-    /// OutArcIt with 'o'.
+        const GR& g;
+      };
+    };
+
+    /// \brief Concept class for \c InArcIt, \c OutArcIt and 
+    /// \c IncEdgeIt types.
+    ///
+    /// This class describes the concept of \c InArcIt, \c OutArcIt 
+    /// and \c IncEdgeIt subtypes of digraph and graph types.
+    ///
+    /// \note Since these iterator classes do not inherit from the same
+    /// base class, there is an additional template parameter (selector)
+    /// \c sel. For \c InArcIt you should instantiate it with character 
+    /// \c 'i', for \c OutArcIt with \c 'o' and for \c IncEdgeIt with \c 'e'.
     template <typename GR,
               typename Item = typename GR::Arc,
@@ -500,37 +516,43 @@
       /// \brief Default constructor.
       ///
-      /// @warning The default constructor sets the iterator
-      /// to an undefined value.
+      /// Default constructor.
+      /// \warning The default constructor is not required to set
+      /// the iterator to some well-defined value. So you should consider it
+      /// as uninitialized.
       GraphIncIt() {}
+
       /// \brief Copy constructor.
       ///
       /// Copy constructor.
-      ///
-      GraphIncIt(GraphIncIt const& gi) : Item(gi) {}
-      /// \brief Sets the iterator to the first arc incoming into or outgoing
-      /// from the node.
-      ///
-      /// Sets the iterator to the first arc incoming into or outgoing
-      /// from the node.
-      ///
+      GraphIncIt(const GraphIncIt& it) : Item(it) {}
+
+      /// \brief Constructor that sets the iterator to the first 
+      /// incoming or outgoing arc.
+      ///
+      /// Constructor that sets the iterator to the first arc 
+      /// incoming to or outgoing from the given node.
       explicit GraphIncIt(const GR&, const Base&) {}
-      /// \brief Invalid constructor \& conversion.
-      ///
-      /// This constructor initializes the item to be invalid.
+
+      /// \brief Constructor for conversion from \c INVALID.
+      ///
+      /// Constructor for conversion from \c INVALID.
+      /// It initializes the iterator to be invalid.
       /// \sa Invalid for more details.
       GraphIncIt(Invalid) {}
-      /// \brief Assign operator for iterators.
-      ///
-      /// The iterators are assignable.
-      ///
-      GraphIncIt& operator=(GraphIncIt const&) { return *this; }
-      /// \brief Next item.
-      ///
-      /// Assign the iterator to the next item.
-      ///
+
+      /// \brief Assignment operator.
+      ///
+      /// Assignment operator for the iterator.
+      GraphIncIt& operator=(const GraphIncIt&) { return *this; }
+
+      /// \brief Increment the iterator.
+      ///
+      /// This operator increments the iterator, i.e. assigns it to the
+      /// next arc incoming to or outgoing from the given node.
       GraphIncIt& operator++() { return *this; }
 
       /// \brief Equality operator
       ///
+      /// Equality operator.
       /// Two iterators are equal if and only if they point to the
       /// same object or both are invalid.
@@ -539,6 +561,7 @@
       /// \brief Inequality operator
       ///
-      /// \sa operator==(Node n)
-      ///
+      /// Inequality operator.
+      /// Two iterators are equal if and only if they point to the
+      /// same object or both are invalid.
       bool operator!=(const GraphIncIt&) const { return true;}
 
@@ -549,4 +572,6 @@
           _GraphIncIt it1(graph, node);
           _GraphIncIt it2;
+          _GraphIncIt it3 = it1;
+          _GraphIncIt it4 = INVALID;
 
           it2 = ++it1;
@@ -555,19 +580,15 @@
           Item e = it1;
           e = it2;
-
-        }
-
-        Item arc;
-        Base node;
-        GR graph;
-        _GraphIncIt it;
-      };
-    };
-
-
-    /// \brief An empty iterable digraph class.
-    ///
-    /// This class provides beside the core digraph features
-    /// iterator based iterable interface for the digraph structure.
+        }
+        const Base& node;
+        const GR& graph;
+      };
+    };
+
+    /// \brief Skeleton class for iterable directed graphs.
+    ///
+    /// This class describes the interface of iterable directed
+    /// graphs. It extends \ref BaseDigraphComponent with the core
+    /// iterable interface.
     /// This concept is part of the Digraph concept.
     template <typename BAS = BaseDigraphComponent>
@@ -584,59 +605,50 @@
       /// \name Base iteration
       ///
-      /// This interface provides functions for iteration on digraph items
+      /// This interface provides functions for iteration on digraph items.
       ///
       /// @{
 
-      /// \brief Gives back the first node in the iterating order.
-      ///
-      /// Gives back the first node in the iterating order.
-      ///
+      /// \brief Return the first node.
+      ///
+      /// This function gives back the first node in the iteration order.
       void first(Node&) const {}
 
-      /// \brief Gives back the next node in the iterating order.
-      ///
-      /// Gives back the next node in the iterating order.
-      ///
+      /// \brief Return the next node.
+      ///
+      /// This function gives back the next node in the iteration order.
       void next(Node&) const {}
 
-      /// \brief Gives back the first arc in the iterating order.
-      ///
-      /// Gives back the first arc in the iterating order.
-      ///
+      /// \brief Return the first arc.
+      ///
+      /// This function gives back the first arc in the iteration order.
       void first(Arc&) const {}
 
-      /// \brief Gives back the next arc in the iterating order.
-      ///
-      /// Gives back the next arc in the iterating order.
-      ///
+      /// \brief Return the next arc.
+      ///
+      /// This function gives back the next arc in the iteration order.
       void next(Arc&) const {}
 
-
-      /// \brief Gives back the first of the arcs point to the given
-      /// node.
-      ///
-      /// Gives back the first of the arcs point to the given node.
-      ///
+      /// \brief Return the first arc incomming to the given node.
+      ///
+      /// This function gives back the first arc incomming to the
+      /// given node.
       void firstIn(Arc&, const Node&) const {}
 
-      /// \brief Gives back the next of the arcs points to the given
-      /// node.
-      ///
-      /// Gives back the next of the arcs points to the given node.
-      ///
+      /// \brief Return the next arc incomming to the given node.
+      ///
+      /// This function gives back the next arc incomming to the
+      /// given node.
       void nextIn(Arc&) const {}
 
-      /// \brief Gives back the first of the arcs start from the
+      /// \brief Return the first arc outgoing form the given node.
+      ///
+      /// This function gives back the first arc outgoing form the
       /// given node.
-      ///
-      /// Gives back the first of the arcs start from the given node.
-      ///
       void firstOut(Arc&, const Node&) const {}
 
-      /// \brief Gives back the next of the arcs start from the given
-      /// node.
-      ///
-      /// Gives back the next of the arcs start from the given node.
-      ///
+      /// \brief Return the next arc outgoing form the given node.
+      ///
+      /// This function gives back the next arc outgoing form the
+      /// given node.
       void nextOut(Arc&) const {}
 
@@ -645,5 +657,5 @@
       /// \name Class based iteration
       ///
-      /// This interface provides functions for iteration on digraph items
+      /// This interface provides iterator classes for digraph items.
       ///
       /// @{
@@ -655,7 +667,7 @@
       typedef GraphItemIt<Digraph, Node> NodeIt;
 
-      /// \brief This iterator goes through each node.
-      ///
-      /// This iterator goes through each node.
+      /// \brief This iterator goes through each arc.
+      ///
+      /// This iterator goes through each arc.
       ///
       typedef GraphItemIt<Digraph, Arc> ArcIt;
@@ -663,5 +675,5 @@
       /// \brief This iterator goes trough the incoming arcs of a node.
       ///
-      /// This iterator goes trough the \e inccoming arcs of a certain node
+      /// This iterator goes trough the \e incoming arcs of a certain node
       /// of a digraph.
       typedef GraphIncIt<Digraph, Arc, Node, 'i'> InArcIt;
@@ -675,24 +687,24 @@
       /// \brief The base node of the iterator.
       ///
-      /// Gives back the base node of the iterator.
-      /// It is always the target of the pointed arc.
+      /// This function gives back the base node of the iterator.
+      /// It is always the target node of the pointed arc.
       Node baseNode(const InArcIt&) const { return INVALID; }
 
       /// \brief The running node of the iterator.
       ///
-      /// Gives back the running node of the iterator.
-      /// It is always the source of the pointed arc.
+      /// This function gives back the running node of the iterator.
+      /// It is always the source node of the pointed arc.
       Node runningNode(const InArcIt&) const { return INVALID; }
 
       /// \brief The base node of the iterator.
       ///
-      /// Gives back the base node of the iterator.
-      /// It is always the source of the pointed arc.
+      /// This function gives back the base node of the iterator.
+      /// It is always the source node of the pointed arc.
       Node baseNode(const OutArcIt&) const { return INVALID; }
 
       /// \brief The running node of the iterator.
       ///
-      /// Gives back the running node of the iterator.
-      /// It is always the target of the pointed arc.
+      /// This function gives back the running node of the iterator.
+      /// It is always the target node of the pointed arc.
       Node runningNode(const OutArcIt&) const { return INVALID; }
 
@@ -736,10 +748,10 @@
 
             typename _Digraph::Node n;
-            typename _Digraph::InArcIt ieit(INVALID);
-            typename _Digraph::OutArcIt oeit(INVALID);
-            n = digraph.baseNode(ieit);
-            n = digraph.runningNode(ieit);
-            n = digraph.baseNode(oeit);
-            n = digraph.runningNode(oeit);
+            const typename _Digraph::InArcIt iait(INVALID);
+            const typename _Digraph::OutArcIt oait(INVALID);
+            n = digraph.baseNode(iait);
+            n = digraph.runningNode(iait);
+            n = digraph.baseNode(oait);
+            n = digraph.runningNode(oait);
             ignore_unused_variable_warning(n);
           }
@@ -747,12 +759,12 @@
 
         const _Digraph& digraph;
-
-      };
-    };
-
-    /// \brief An empty iterable undirected graph class.
-    ///
-    /// This class provides beside the core graph features iterator
-    /// based iterable interface for the undirected graph structure.
+      };
+    };
+
+    /// \brief Skeleton class for iterable undirected graphs.
+    ///
+    /// This class describes the interface of iterable undirected
+    /// graphs. It extends \ref IterableDigraphComponent with the core
+    /// iterable interface of undirected graphs.
     /// This concept is part of the Graph concept.
     template <typename BAS = BaseGraphComponent>
@@ -770,5 +782,6 @@
       /// \name Base iteration
       ///
-      /// This interface provides functions for iteration on graph items
+      /// This interface provides functions for iteration on edges.
+      ///
       /// @{
 
@@ -776,26 +789,20 @@
       using IterableDigraphComponent<Base>::next;
 
-      /// \brief Gives back the first edge in the iterating
-      /// order.
-      ///
-      /// Gives back the first edge in the iterating order.
-      ///
+      /// \brief Return the first edge.
+      ///
+      /// This function gives back the first edge in the iteration order.
       void first(Edge&) const {}
 
-      /// \brief Gives back the next edge in the iterating
-      /// order.
-      ///
-      /// Gives back the next edge in the iterating order.
-      ///
+      /// \brief Return the next edge.
+      ///
+      /// This function gives back the next edge in the iteration order.
       void next(Edge&) const {}
 
-
-      /// \brief Gives back the first of the edges from the
+      /// \brief Return the first edge incident to the given node.
+      ///
+      /// This function gives back the first edge incident to the given 
+      /// node. The bool parameter gives back the direction for which the
+      /// source node of the directed arc representing the edge is the 
       /// given node.
-      ///
-      /// Gives back the first of the edges from the given
-      /// node. The bool parameter gives back that direction which
-      /// gives a good direction of the edge so the source of the
-      /// directed arc is the given node.
       void firstInc(Edge&, bool&, const Node&) const {}
 
@@ -803,7 +810,6 @@
       /// given node.
       ///
-      /// Gives back the next of the edges from the given
-      /// node. The bool parameter should be used as the \c firstInc()
-      /// use it.
+      /// This function gives back the next edge incident to the given 
+      /// node. The bool parameter should be used as \c firstInc() use it.
       void nextInc(Edge&, bool&) const {}
 
@@ -815,26 +821,28 @@
       /// \name Class based iteration
       ///
-      /// This interface provides functions for iteration on graph items
+      /// This interface provides iterator classes for edges.
       ///
       /// @{
 
-      /// \brief This iterator goes through each node.
-      ///
-      /// This iterator goes through each node.
+      /// \brief This iterator goes through each edge.
+      ///
+      /// This iterator goes through each edge.
       typedef GraphItemIt<Graph, Edge> EdgeIt;
-      /// \brief This iterator goes trough the incident arcs of a
+
+      /// \brief This iterator goes trough the incident edges of a
       /// node.
       ///
-      /// This iterator goes trough the incident arcs of a certain
+      /// This iterator goes trough the incident edges of a certain
       /// node of a graph.
-      typedef GraphIncIt<Graph, Edge, Node, 'u'> IncEdgeIt;
+      typedef GraphIncIt<Graph, Edge, Node, 'e'> IncEdgeIt;
+
       /// \brief The base node of the iterator.
       ///
-      /// Gives back the base node of the iterator.
+      /// This function gives back the base node of the iterator.
       Node baseNode(const IncEdgeIt&) const { return INVALID; }
 
       /// \brief The running node of the iterator.
       ///
-      /// Gives back the running node of the iterator.
+      /// This function gives back the running node of the iterator.
       Node runningNode(const IncEdgeIt&) const { return INVALID; }
 
@@ -865,10 +873,10 @@
               typename _Graph::EdgeIt >();
             checkConcept<GraphIncIt<_Graph, typename _Graph::Edge,
-              typename _Graph::Node, 'u'>, typename _Graph::IncEdgeIt>();
+              typename _Graph::Node, 'e'>, typename _Graph::IncEdgeIt>();
 
             typename _Graph::Node n;
-            typename _Graph::IncEdgeIt ueit(INVALID);
-            n = graph.baseNode(ueit);
-            n = graph.runningNode(ueit);
+            const typename _Graph::IncEdgeIt ieit(INVALID);
+            n = graph.baseNode(ieit);
+            n = graph.runningNode(ieit);
           }
         }
@@ -878,11 +886,12 @@
     };
 
-    /// \brief An empty alteration notifier digraph class.
-    ///
-    /// This class provides beside the core digraph features alteration
-    /// notifier interface for the digraph structure.  This implements
+    /// \brief Skeleton class for alterable directed graphs.
+    ///
+    /// This class describes the interface of alterable directed
+    /// graphs. It extends \ref BaseDigraphComponent with the alteration
+    /// notifier interface. It implements
     /// an observer-notifier pattern for each digraph item. More
     /// obsevers can be registered into the notifier and whenever an
-    /// alteration occured in the digraph all the observers will
+    /// alteration occured in the digraph all the observers will be
     /// notified about it.
     template <typename BAS = BaseDigraphComponent>
@@ -895,21 +904,21 @@
 
 
-      /// The node observer registry.
+      /// Node alteration notifier class.
       typedef AlterationNotifier<AlterableDigraphComponent, Node>
       NodeNotifier;
-      /// The arc observer registry.
+      /// Arc alteration notifier class.
       typedef AlterationNotifier<AlterableDigraphComponent, Arc>
       ArcNotifier;
 
-      /// \brief Gives back the node alteration notifier.
-      ///
-      /// Gives back the node alteration notifier.
+      /// \brief Return the node alteration notifier.
+      ///
+      /// This function gives back the node alteration notifier.
       NodeNotifier& notifier(Node) const {
-        return NodeNotifier();
+         return NodeNotifier();
       }
 
-      /// \brief Gives back the arc alteration notifier.
-      ///
-      /// Gives back the arc alteration notifier.
+      /// \brief Return the arc alteration notifier.
+      ///
+      /// This function gives back the arc alteration notifier.
       ArcNotifier& notifier(Arc) const {
         return ArcNotifier();
@@ -931,16 +940,15 @@
 
         const _Digraph& digraph;
-
-      };
-
-    };
-
-    /// \brief An empty alteration notifier undirected graph class.
-    ///
-    /// This class provides beside the core graph features alteration
-    /// notifier interface for the graph structure.  This implements
-    /// an observer-notifier pattern for each graph item. More
+      };
+    };
+
+    /// \brief Skeleton class for alterable undirected graphs.
+    ///
+    /// This class describes the interface of alterable undirected
+    /// graphs. It extends \ref AlterableDigraphComponent with the alteration
+    /// notifier interface of undirected graphs. It implements
+    /// an observer-notifier pattern for the edges. More
     /// obsevers can be registered into the notifier and whenever an
-    /// alteration occured in the graph all the observers will
+    /// alteration occured in the graph all the observers will be
     /// notified about it.
     template <typename BAS = BaseGraphComponent>
@@ -952,11 +960,11 @@
 
 
-      /// The arc observer registry.
+      /// Edge alteration notifier class.
       typedef AlterationNotifier<AlterableGraphComponent, Edge>
       EdgeNotifier;
 
-      /// \brief Gives back the arc alteration notifier.
-      ///
-      /// Gives back the arc alteration notifier.
+      /// \brief Return the edge alteration notifier.
+      ///
+      /// This function gives back the edge alteration notifier.
       EdgeNotifier& notifier(Edge) const {
         return EdgeNotifier();
@@ -966,5 +974,5 @@
       struct Constraints {
         void constraints() {
-          checkConcept<AlterableGraphComponent<Base>, _Graph>();
+          checkConcept<AlterableDigraphComponent<Base>, _Graph>();
           typename _Graph::EdgeNotifier& uen
             = graph.notifier(typename _Graph::Edge());
@@ -976,9 +984,9 @@
     };
 
-    /// \brief Class describing the concept of graph maps
-    ///
-    /// This class describes the common interface of the graph maps
-    /// (NodeMap, ArcMap), that is maps that can be used to
-    /// associate data to graph descriptors (nodes or arcs).
+    /// \brief Concept class for standard graph maps.
+    ///
+    /// This class describes the concept of standard graph maps, i.e.
+    /// the \c NodeMap, \c ArcMap and \c EdgeMap subtypes of digraph and 
+    /// graph types, which can be used for associating data to graph items.
     template <typename GR, typename K, typename V>
     class GraphMap : public ReadWriteMap<K, V> {
@@ -1000,5 +1008,5 @@
       /// \brief Construct a new map with default value.
       ///
-      /// Construct a new map for the graph and initalise the values.
+      /// Construct a new map for the graph and initalize the values.
       GraphMap(const Graph&, const Value&) {}
 
@@ -1009,7 +1017,7 @@
       GraphMap(const GraphMap&) : Parent() {}
 
-      /// \brief Assign operator.
-      ///
-      /// Assign operator. It does not mofify the underlying graph,
+      /// \brief Assignment operator.
+      ///
+      /// Assignment operator. It does not mofify the underlying graph,
       /// it just iterates on the current item set and set the  map
       /// with the value returned by the assigned map.
@@ -1025,20 +1033,20 @@
         void constraints() {
           checkConcept<ReadWriteMap<Key, Value>, _Map >();
-          // Construction with a graph parameter
-          _Map a(g);
-          // Constructor with a graph and a default value parameter
-          _Map a2(g,t);
-          // Copy constructor.
-          // _Map b(c);
-
+          _Map m1(g);
+          _Map m2(g,t);
+          
+          // Copy constructor
+          // _Map m3(m);
+
+          // Assignment operator
           // ReadMap<Key, Value> cmap;
-          // b = cmap;
-
-          ignore_unused_variable_warning(a);
-          ignore_unused_variable_warning(a2);
-          // ignore_unused_variable_warning(b);
-        }
-
-        const _Map &c;
+          // m3 = cmap;
+
+          ignore_unused_variable_warning(m1);
+          ignore_unused_variable_warning(m2);
+          // ignore_unused_variable_warning(m3);
+        }
+
+        const _Map &m;
         const Graph &g;
         const typename GraphMap::Value &t;
@@ -1047,8 +1055,9 @@
     };
 
-    /// \brief An empty mappable digraph class.
-    ///
-    /// This class provides beside the core digraph features
-    /// map interface for the digraph structure.
+    /// \brief Skeleton class for mappable directed graphs.
+    ///
+    /// This class describes the interface of mappable directed graphs.
+    /// It extends \ref BaseDigraphComponent with the standard digraph 
+    /// map classes, namely \c NodeMap and \c ArcMap.
     /// This concept is part of the Digraph concept.
     template <typename BAS = BaseDigraphComponent>
@@ -1062,10 +1071,9 @@
       typedef MappableDigraphComponent Digraph;
 
-      /// \brief ReadWrite map of the nodes.
-      ///
-      /// ReadWrite map of the nodes.
-      ///
+      /// \brief Standard graph map for the nodes.
+      ///
+      /// Standard graph map for the nodes.
       template <typename V>
-      class NodeMap : public GraphMap<Digraph, Node, V> {
+      class NodeMap : public GraphMap<MappableDigraphComponent, Node, V> {
       public:
         typedef GraphMap<MappableDigraphComponent, Node, V> Parent;
@@ -1079,5 +1087,5 @@
         /// \brief Construct a new map with default value.
         ///
-        /// Construct a new map for the digraph and initalise the values.
+        /// Construct a new map for the digraph and initalize the values.
         NodeMap(const MappableDigraphComponent& digraph, const V& value)
           : Parent(digraph, value) {}
@@ -1089,7 +1097,7 @@
         NodeMap(const NodeMap& nm) : Parent(nm) {}
 
-        /// \brief Assign operator.
-        ///
-        /// Assign operator.
+        /// \brief Assignment operator.
+        ///
+        /// Assignment operator.
         template <typename CMap>
         NodeMap& operator=(const CMap&) {
@@ -1100,10 +1108,9 @@
       };
 
-      /// \brief ReadWrite map of the arcs.
-      ///
-      /// ReadWrite map of the arcs.
-      ///
+      /// \brief Standard graph map for the arcs.
+      ///
+      /// Standard graph map for the arcs.
       template <typename V>
-      class ArcMap : public GraphMap<Digraph, Arc, V> {
+      class ArcMap : public GraphMap<MappableDigraphComponent, Arc, V> {
       public:
         typedef GraphMap<MappableDigraphComponent, Arc, V> Parent;
@@ -1117,5 +1124,5 @@
         /// \brief Construct a new map with default value.
         ///
-        /// Construct a new map for the digraph and initalise the values.
+        /// Construct a new map for the digraph and initalize the values.
         ArcMap(const MappableDigraphComponent& digraph, const V& value)
           : Parent(digraph, value) {}
@@ -1127,7 +1134,7 @@
         ArcMap(const ArcMap& nm) : Parent(nm) {}
 
-        /// \brief Assign operator.
-        ///
-        /// Assign operator.
+        /// \brief Assignment operator.
+        ///
+        /// Assignment operator.
         template <typename CMap>
         ArcMap& operator=(const CMap&) {
@@ -1179,12 +1186,13 @@
         }
 
-        _Digraph& digraph;
-      };
-    };
-
-    /// \brief An empty mappable base bipartite graph class.
-    ///
-    /// This class provides beside the core graph features
-    /// map interface for the graph structure.
+        const _Digraph& digraph;
+      };
+    };
+
+    /// \brief Skeleton class for mappable undirected graphs.
+    ///
+    /// This class describes the interface of mappable undirected graphs.
+    /// It extends \ref MappableDigraphComponent with the standard graph 
+    /// map class for edges (\c EdgeMap).
     /// This concept is part of the Graph concept.
     template <typename BAS = BaseGraphComponent>
@@ -1197,10 +1205,9 @@
       typedef MappableGraphComponent Graph;
 
-      /// \brief ReadWrite map of the edges.
-      ///
-      /// ReadWrite map of the edges.
-      ///
+      /// \brief Standard graph map for the edges.
+      ///
+      /// Standard graph map for the edges.
       template <typename V>
-      class EdgeMap : public GraphMap<Graph, Edge, V> {
+      class EdgeMap : public GraphMap<MappableGraphComponent, Edge, V> {
       public:
         typedef GraphMap<MappableGraphComponent, Edge, V> Parent;
@@ -1214,5 +1221,5 @@
         /// \brief Construct a new map with default value.
         ///
-        /// Construct a new map for the graph and initalise the values.
+        /// Construct a new map for the graph and initalize the values.
         EdgeMap(const MappableGraphComponent& graph, const V& value)
           : Parent(graph, value) {}
@@ -1224,7 +1231,7 @@
         EdgeMap(const EdgeMap& nm) : Parent(nm) {}
 
-        /// \brief Assign operator.
-        ///
-        /// Assign operator.
+        /// \brief Assignment operator.
+        ///
+        /// Assignment operator.
         template <typename CMap>
         EdgeMap& operator=(const CMap&) {
@@ -1246,5 +1253,5 @@
 
         void constraints() {
-          checkConcept<MappableGraphComponent<Base>, _Graph>();
+          checkConcept<MappableDigraphComponent<Base>, _Graph>();
 
           { // int map test
@@ -1263,14 +1270,14 @@
         }
 
-        _Graph& graph;
-      };
-    };
-
-    /// \brief An empty extendable digraph class.
-    ///
-    /// This class provides beside the core digraph features digraph
-    /// extendable interface for the digraph structure.  The main
-    /// difference between the base and this interface is that the
-    /// digraph alterations should handled already on this level.
+        const _Graph& graph;
+      };
+    };
+
+    /// \brief Skeleton class for extendable directed graphs.
+    ///
+    /// This class describes the interface of extendable directed graphs.
+    /// It extends \ref BaseDigraphComponent with functions for adding 
+    /// nodes and arcs to the digraph.
+    /// This concept requires \ref AlterableDigraphComponent.
     template <typename BAS = BaseDigraphComponent>
     class ExtendableDigraphComponent : public BAS {
@@ -1281,15 +1288,15 @@
       typedef typename Base::Arc Arc;
 
-      /// \brief Adds a new node to the digraph.
-      ///
-      /// Adds a new node to the digraph.
-      ///
+      /// \brief Add a new node to the digraph.
+      ///
+      /// This function adds a new node to the digraph.
       Node addNode() {
         return INVALID;
       }
 
-      /// \brief Adds a new arc connects the given two nodes.
-      ///
-      /// Adds a new arc connects the the given two nodes.
+      /// \brief Add a new arc connecting the given two nodes.
+      ///
+      /// This function adds a new arc connecting the given two nodes
+      /// of the digraph.
       Arc addArc(const Node&, const Node&) {
         return INVALID;
@@ -1311,11 +1318,10 @@
     };
 
-    /// \brief An empty extendable base undirected graph class.
-    ///
-    /// This class provides beside the core undirected graph features
-    /// core undircted graph extend interface for the graph structure.
-    /// The main difference between the base and this interface is
-    /// that the graph alterations should handled already on this
-    /// level.
+    /// \brief Skeleton class for extendable undirected graphs.
+    ///
+    /// This class describes the interface of extendable undirected graphs.
+    /// It extends \ref BaseGraphComponent with functions for adding 
+    /// nodes and edges to the graph.
+    /// This concept requires \ref AlterableGraphComponent.
     template <typename BAS = BaseGraphComponent>
     class ExtendableGraphComponent : public BAS {
@@ -1326,16 +1332,16 @@
       typedef typename Base::Edge Edge;
 
-      /// \brief Adds a new node to the graph.
-      ///
-      /// Adds a new node to the graph.
-      ///
+      /// \brief Add a new node to the digraph.
+      ///
+      /// This function adds a new node to the digraph.
       Node addNode() {
         return INVALID;
       }
 
-      /// \brief Adds a new arc connects the given two nodes.
-      ///
-      /// Adds a new arc connects the the given two nodes.
-      Edge addArc(const Node&, const Node&) {
+      /// \brief Add a new edge connecting the given two nodes.
+      ///
+      /// This function adds a new edge connecting the given two nodes
+      /// of the graph.
+      Edge addEdge(const Node&, const Node&) {
         return INVALID;
       }
@@ -1356,10 +1362,10 @@
     };
 
-    /// \brief An empty erasable digraph class.
-    ///
-    /// This class provides beside the core digraph features core erase
-    /// functions for the digraph structure. The main difference between
-    /// the base and this interface is that the digraph alterations
-    /// should handled already on this level.
+    /// \brief Skeleton class for erasable directed graphs.
+    ///
+    /// This class describes the interface of erasable directed graphs.
+    /// It extends \ref BaseDigraphComponent with functions for removing 
+    /// nodes and arcs from the digraph.
+    /// This concept requires \ref AlterableDigraphComponent.
     template <typename BAS = BaseDigraphComponent>
     class ErasableDigraphComponent : public BAS {
@@ -1372,12 +1378,11 @@
       /// \brief Erase a node from the digraph.
       ///
-      /// Erase a node from the digraph. This function should
-      /// erase all arcs connecting to the node.
+      /// This function erases the given node from the digraph and all arcs 
+      /// connected to the node.
       void erase(const Node&) {}
 
       /// \brief Erase an arc from the digraph.
       ///
-      /// Erase an arc from the digraph.
-      ///
+      /// This function erases the given arc from the digraph.
       void erase(const Arc&) {}
 
@@ -1386,7 +1391,7 @@
         void constraints() {
           checkConcept<Base, _Digraph>();
-          typename _Digraph::Node node;
+          const typename _Digraph::Node node(INVALID);
           digraph.erase(node);
-          typename _Digraph::Arc arc;
+          const typename _Digraph::Arc arc(INVALID);
           digraph.erase(arc);
         }
@@ -1396,10 +1401,10 @@
     };
 
-    /// \brief An empty erasable base undirected graph class.
-    ///
-    /// This class provides beside the core undirected graph features
-    /// core erase functions for the undirceted graph structure. The
-    /// main difference between the base and this interface is that
-    /// the graph alterations should handled already on this level.
+    /// \brief Skeleton class for erasable undirected graphs.
+    ///
+    /// This class describes the interface of erasable undirected graphs.
+    /// It extends \ref BaseGraphComponent with functions for removing 
+    /// nodes and edges from the graph.
+    /// This concept requires \ref AlterableGraphComponent.
     template <typename BAS = BaseGraphComponent>
     class ErasableGraphComponent : public BAS {
@@ -1412,12 +1417,11 @@
       /// \brief Erase a node from the graph.
       ///
-      /// Erase a node from the graph. This function should erase
-      /// arcs connecting to the node.
+      /// This function erases the given node from the graph and all edges
+      /// connected to the node.
       void erase(const Node&) {}
 
-      /// \brief Erase an arc from the graph.
-      ///
-      /// Erase an arc from the graph.
-      ///
+      /// \brief Erase an edge from the digraph.
+      ///
+      /// This function erases the given edge from the digraph.
       void erase(const Edge&) {}
 
@@ -1426,7 +1430,7 @@
         void constraints() {
           checkConcept<Base, _Graph>();
-          typename _Graph::Node node;
+          const typename _Graph::Node node(INVALID);
           graph.erase(node);
-          typename _Graph::Edge edge;
+          const typename _Graph::Edge edge(INVALID);
           graph.erase(edge);
         }
@@ -1436,10 +1440,10 @@
     };
 
-    /// \brief An empty clearable base digraph class.
-    ///
-    /// This class provides beside the core digraph features core clear
-    /// functions for the digraph structure. The main difference between
-    /// the base and this interface is that the digraph alterations
-    /// should handled already on this level.
+    /// \brief Skeleton class for clearable directed graphs.
+    ///
+    /// This class describes the interface of clearable directed graphs.
+    /// It extends \ref BaseDigraphComponent with a function for clearing
+    /// the digraph.
+    /// This concept requires \ref AlterableDigraphComponent.
     template <typename BAS = BaseDigraphComponent>
     class ClearableDigraphComponent : public BAS {
@@ -1450,6 +1454,5 @@
       /// \brief Erase all nodes and arcs from the digraph.
       ///
-      /// Erase all nodes and arcs from the digraph.
-      ///
+      /// This function erases all nodes and arcs from the digraph.
       void clear() {}
 
@@ -1461,14 +1464,14 @@
         }
 
-        _Digraph digraph;
-      };
-    };
-
-    /// \brief An empty clearable base undirected graph class.
-    ///
-    /// This class provides beside the core undirected graph features
-    /// core clear functions for the undirected graph structure. The
-    /// main difference between the base and this interface is that
-    /// the graph alterations should handled already on this level.
+        _Digraph& digraph;
+      };
+    };
+
+    /// \brief Skeleton class for clearable undirected graphs.
+    ///
+    /// This class describes the interface of clearable undirected graphs.
+    /// It extends \ref BaseGraphComponent with a function for clearing
+    /// the graph.
+    /// This concept requires \ref AlterableGraphComponent.
     template <typename BAS = BaseGraphComponent>
     class ClearableGraphComponent : public ClearableDigraphComponent<BAS> {
@@ -1477,11 +1480,17 @@
       typedef BAS Base;
 
+      /// \brief Erase all nodes and edges from the graph.
+      ///
+      /// This function erases all nodes and edges from the graph.
+      void clear() {}
+
       template <typename _Graph>
       struct Constraints {
         void constraints() {
-          checkConcept<ClearableGraphComponent<Base>, _Graph>();
-        }
-
-        _Graph graph;
+          checkConcept<Base, _Graph>();
+          graph.clear();
+        }
+
+        _Graph& graph;
       };
     };
Index: lemon/cplex.cc
===================================================================
--- lemon/cplex.cc	(revision 623)
+++ lemon/cplex.cc	(revision 598)
@@ -73,5 +73,4 @@
     int status;
     _prob = CPXcreateprob(cplexEnv(), &status, "Cplex problem");
-    messageLevel(MESSAGE_NOTHING);
   }
 
@@ -80,5 +79,4 @@
     int status;
     _prob = CPXcreateprob(cplexEnv(), &status, "Cplex problem");
-    messageLevel(MESSAGE_NOTHING);
   }
 
@@ -89,5 +87,4 @@
     rows = cplex.rows;
     cols = cplex.cols;
-    messageLevel(MESSAGE_NOTHING);
   }
 
@@ -440,23 +437,4 @@
     rows.clear();
     cols.clear();
-  }
-
-  void CplexBase::_messageLevel(MessageLevel level) {
-    switch (level) {
-    case MESSAGE_NOTHING:
-      _message_enabled = false;
-      break;
-    case MESSAGE_ERROR:
-    case MESSAGE_WARNING:
-    case MESSAGE_NORMAL:
-    case MESSAGE_VERBOSE:
-      _message_enabled = true;
-      break;
-    }
-  }
-
-  void CplexBase::_applyMessageLevel() {
-    CPXsetintparam(cplexEnv(), CPX_PARAM_SCRIND, 
-                   _message_enabled ? CPX_ON : CPX_OFF);
   }
 
@@ -530,5 +508,4 @@
   CplexLp::SolveExitStatus CplexLp::_solve() {
     _clear_temporals();
-    _applyMessageLevel();
     return convertStatus(CPXlpopt(cplexEnv(), _prob));
   }
@@ -536,5 +513,4 @@
   CplexLp::SolveExitStatus CplexLp::solvePrimal() {
     _clear_temporals();
-    _applyMessageLevel();
     return convertStatus(CPXprimopt(cplexEnv(), _prob));
   }
@@ -542,5 +518,4 @@
   CplexLp::SolveExitStatus CplexLp::solveDual() {
     _clear_temporals();
-    _applyMessageLevel();
     return convertStatus(CPXdualopt(cplexEnv(), _prob));
   }
@@ -548,5 +523,4 @@
   CplexLp::SolveExitStatus CplexLp::solveBarrier() {
     _clear_temporals();
-    _applyMessageLevel();
     return convertStatus(CPXbaropt(cplexEnv(), _prob));
   }
@@ -627,5 +601,5 @@
   }
 
-  // Cplex 7.0 status values
+  //7.5-os cplex statusai (Vigyazat: a 9.0-asei masok!)
   // This table lists the statuses, returned by the CPXgetstat()
   // routine, for solutions to LP problems or mixed integer problems. If
@@ -674,5 +648,5 @@
   //       User pivot used
   //
-  // Pending return values
+  //     Ezeket hova tegyem:
   // ??case CPX_ABORT_DUAL_INFEAS
   // ??case CPX_ABORT_CROSSOVER
@@ -745,4 +719,5 @@
     statusSwitch(cplexEnv(),stat);
     //CPXgetstat(cplexEnv(), _prob);
+    //printf("A primal status: %d, CPX_OPTIMAL=%d \n",stat,CPX_OPTIMAL);
     switch (stat) {
     case 0:
@@ -777,5 +752,5 @@
   }
 
-  // Cplex 9.0 status values
+  //9.0-as cplex verzio statusai
   // CPX_STAT_ABORT_DUAL_OBJ_LIM
   // CPX_STAT_ABORT_IT_LIM
@@ -890,5 +865,4 @@
   CplexMip::SolveExitStatus CplexMip::_solve() {
     int status;
-    _applyMessageLevel();
     status = CPXmipopt (cplexEnv(), _prob);
     if (status==0)
Index: lemon/cplex.h
===================================================================
--- lemon/cplex.h	(revision 623)
+++ lemon/cplex.h	(revision 598)
@@ -145,27 +145,12 @@
     virtual void _clear();
 
-    virtual void _messageLevel(MessageLevel level);
-    void _applyMessageLevel();
-
-    bool _message_enabled;
-
   public:
 
     /// Returns the used \c CplexEnv instance
     const CplexEnv& env() const { return _env; }
-
-    /// \brief Returns the const cpxenv pointer
     ///
-    /// \note The cpxenv might be destructed with the solver.
     const cpxenv* cplexEnv() const { return _env.cplexEnv(); }
 
-    /// \brief Returns the const cpxenv pointer
-    ///
-    /// \note The cpxenv might be destructed with the solver.
-    cpxenv* cplexEnv() { return _env.cplexEnv(); }
-
-    /// Returns the cplex problem object
     cpxlp* cplexLp() { return _prob; }
-    /// Returns the cplex problem object
     const cpxlp* cplexLp() const { return _prob; }
 
Index: lemon/glpk.cc
===================================================================
--- lemon/glpk.cc	(revision 623)
+++ lemon/glpk.cc	(revision 613)
@@ -32,5 +32,4 @@
     lp = glp_create_prob();
     glp_create_index(lp);
-    messageLevel(MESSAGE_NOTHING);
   }
 
@@ -41,5 +40,4 @@
     rows = other.rows;
     cols = other.cols;
-    messageLevel(MESSAGE_NOTHING);
   }
 
@@ -529,24 +527,4 @@
   }
 
-  void GlpkBase::_messageLevel(MessageLevel level) {
-    switch (level) {
-    case MESSAGE_NOTHING:
-      _message_level = GLP_MSG_OFF;
-      break;
-    case MESSAGE_ERROR:
-      _message_level = GLP_MSG_ERR;
-      break;
-    case MESSAGE_WARNING:
-      _message_level = GLP_MSG_ERR;
-      break;
-    case MESSAGE_NORMAL:
-      _message_level = GLP_MSG_ON;
-      break;
-    case MESSAGE_VERBOSE:
-      _message_level = GLP_MSG_ALL;
-      break;
-    }
-  }
-
   GlpkBase::FreeEnvHelper GlpkBase::freeEnvHelper;
 
@@ -555,4 +533,5 @@
   GlpkLp::GlpkLp()
     : LpBase(), LpSolver(), GlpkBase() {
+    messageLevel(MESSAGE_NO_OUTPUT);
     presolver(false);
   }
@@ -560,4 +539,5 @@
   GlpkLp::GlpkLp(const GlpkLp& other)
     : LpBase(other), LpSolver(other), GlpkBase(other) {
+    messageLevel(MESSAGE_NO_OUTPUT);
     presolver(false);
   }
@@ -583,5 +563,18 @@
     glp_init_smcp(&smcp);
 
-    smcp.msg_lev = _message_level;
+    switch (_message_level) {
+    case MESSAGE_NO_OUTPUT:
+      smcp.msg_lev = GLP_MSG_OFF;
+      break;
+    case MESSAGE_ERROR_MESSAGE:
+      smcp.msg_lev = GLP_MSG_ERR;
+      break;
+    case MESSAGE_NORMAL_OUTPUT:
+      smcp.msg_lev = GLP_MSG_ON;
+      break;
+    case MESSAGE_FULL_OUTPUT:
+      smcp.msg_lev = GLP_MSG_ALL;
+      break;
+    }
     smcp.presolve = _presolve;
 
@@ -612,5 +605,18 @@
     glp_init_smcp(&smcp);
 
-    smcp.msg_lev = _message_level;
+    switch (_message_level) {
+    case MESSAGE_NO_OUTPUT:
+      smcp.msg_lev = GLP_MSG_OFF;
+      break;
+    case MESSAGE_ERROR_MESSAGE:
+      smcp.msg_lev = GLP_MSG_ERR;
+      break;
+    case MESSAGE_NORMAL_OUTPUT:
+      smcp.msg_lev = GLP_MSG_ON;
+      break;
+    case MESSAGE_FULL_OUTPUT:
+      smcp.msg_lev = GLP_MSG_ALL;
+      break;
+    }
     smcp.meth = GLP_DUAL;
     smcp.presolve = _presolve;
@@ -853,12 +859,18 @@
   }
 
+  void GlpkLp::messageLevel(MessageLevel m) {
+    _message_level = m;
+  }
+
   // GlpkMip members
 
   GlpkMip::GlpkMip()
     : LpBase(), MipSolver(), GlpkBase() {
+    messageLevel(MESSAGE_NO_OUTPUT);
   }
 
   GlpkMip::GlpkMip(const GlpkMip& other)
     : LpBase(), MipSolver(), GlpkBase(other) {
+    messageLevel(MESSAGE_NO_OUTPUT);
   }
 
@@ -889,5 +901,18 @@
     glp_init_smcp(&smcp);
 
-    smcp.msg_lev = _message_level;
+    switch (_message_level) {
+    case MESSAGE_NO_OUTPUT:
+      smcp.msg_lev = GLP_MSG_OFF;
+      break;
+    case MESSAGE_ERROR_MESSAGE:
+      smcp.msg_lev = GLP_MSG_ERR;
+      break;
+    case MESSAGE_NORMAL_OUTPUT:
+      smcp.msg_lev = GLP_MSG_ON;
+      break;
+    case MESSAGE_FULL_OUTPUT:
+      smcp.msg_lev = GLP_MSG_ALL;
+      break;
+    }
     smcp.meth = GLP_DUAL;
 
@@ -914,5 +939,18 @@
     glp_init_iocp(&iocp);
 
-    iocp.msg_lev = _message_level;
+    switch (_message_level) {
+    case MESSAGE_NO_OUTPUT:
+      iocp.msg_lev = GLP_MSG_OFF;
+      break;
+    case MESSAGE_ERROR_MESSAGE:
+      iocp.msg_lev = GLP_MSG_ERR;
+      break;
+    case MESSAGE_NORMAL_OUTPUT:
+      iocp.msg_lev = GLP_MSG_ON;
+      break;
+    case MESSAGE_FULL_OUTPUT:
+      iocp.msg_lev = GLP_MSG_ALL;
+      break;
+    }
 
     if (glp_intopt(lp, &iocp) != 0) return UNSOLVED;
@@ -965,3 +1003,7 @@
   const char* GlpkMip::_solverName() const { return "GlpkMip"; }
 
+  void GlpkMip::messageLevel(MessageLevel m) {
+    _message_level = m;
+  }
+
 } //END OF NAMESPACE LEMON
Index: lemon/glpk.h
===================================================================
--- lemon/glpk.h	(revision 623)
+++ lemon/glpk.h	(revision 612)
@@ -100,6 +100,4 @@
 
     virtual void _clear();
-
-    virtual void _messageLevel(MessageLevel level);
 
   private:
@@ -114,8 +112,4 @@
     
     static FreeEnvHelper freeEnvHelper;
-
-  protected:
-    
-    int _message_level;
     
   public:
@@ -198,4 +192,28 @@
     void presolver(bool presolve);
 
+    ///Enum for \c messageLevel() parameter
+    enum MessageLevel {
+      /// no output (default value)
+      MESSAGE_NO_OUTPUT = 0,
+      /// error messages only
+      MESSAGE_ERROR_MESSAGE = 1,
+      /// normal output
+      MESSAGE_NORMAL_OUTPUT = 2,
+      /// full output (includes informational messages)
+      MESSAGE_FULL_OUTPUT = 3
+    };
+
+  private:
+
+    MessageLevel _message_level;
+
+  public:
+
+    ///Set the verbosity of the messages
+
+    ///Set the verbosity of the messages
+    ///
+    ///\param m is the level of the messages output by the solver routines.
+    void messageLevel(MessageLevel m);
   };
 
@@ -227,4 +245,28 @@
     virtual Value _getSolValue() const;
 
+    ///Enum for \c messageLevel() parameter
+    enum MessageLevel {
+      /// no output (default value)
+      MESSAGE_NO_OUTPUT = 0,
+      /// error messages only
+      MESSAGE_ERROR_MESSAGE = 1,
+      /// normal output
+      MESSAGE_NORMAL_OUTPUT = 2,
+      /// full output (includes informational messages)
+      MESSAGE_FULL_OUTPUT = 3
+    };
+
+  private:
+
+    MessageLevel _message_level;
+
+  public:
+
+    ///Set the verbosity of the messages
+
+    ///Set the verbosity of the messages
+    ///
+    ///\param m is the level of the messages output by the solver routines.
+    void messageLevel(MessageLevel m);
   };
 
Index: lemon/lp_base.h
===================================================================
--- lemon/lp_base.h	(revision 623)
+++ lemon/lp_base.h	(revision 587)
@@ -69,19 +69,4 @@
       MAX
     };
-
-    ///Enum for \c messageLevel() parameter
-    enum MessageLevel {
-      /// no output (default value)
-      MESSAGE_NOTHING,
-      /// error messages only
-      MESSAGE_ERROR,
-      /// warnings
-      MESSAGE_WARNING,
-      /// normal output
-      MESSAGE_NORMAL,
-      /// verbose output
-      MESSAGE_VERBOSE
-    };
-    
 
     ///The floating point type used by the solver
@@ -989,6 +974,4 @@
     virtual const char* _solverName() const = 0;
 
-    virtual void _messageLevel(MessageLevel level) = 0;
-
     //Own protected stuff
 
@@ -1545,7 +1528,4 @@
     void clear() { _clear(); }
 
-    /// Sets the message level of the solver
-    void messageLevel(MessageLevel level) { _messageLevel(level); }
-
     ///@}
 
Index: lemon/lp_skeleton.cc
===================================================================
--- lemon/lp_skeleton.cc	(revision 623)
+++ lemon/lp_skeleton.cc	(revision 587)
@@ -85,6 +85,4 @@
   }
 
-  void SkeletonSolverBase::_messageLevel(MessageLevel) {}
-
   LpSkeleton::SolveExitStatus LpSkeleton::_solve() { return SOLVED; }
 
Index: lemon/lp_skeleton.h
===================================================================
--- lemon/lp_skeleton.h	(revision 623)
+++ lemon/lp_skeleton.h	(revision 588)
@@ -141,6 +141,4 @@
     virtual void _clear();
 
-    ///\e
-    virtual void _messageLevel(MessageLevel);
   };
 
Index: lemon/soplex.cc
===================================================================
--- lemon/soplex.cc	(revision 623)
+++ lemon/soplex.cc	(revision 587)
@@ -21,5 +21,4 @@
 
 #include <soplex.h>
-#include <spxout.h>
 
 
@@ -30,5 +29,4 @@
   SoplexLp::SoplexLp() {
     soplex = new soplex::SoPlex;
-    messageLevel(MESSAGE_NOTHING);
   }
 
@@ -50,5 +48,4 @@
     _row_names_ref = lp._row_names_ref;
 
-    messageLevel(MESSAGE_NOTHING);
   }
 
@@ -275,6 +272,4 @@
 
     _clear_temporals();
-    
-    _applyMessageLevel();
 
     soplex::SPxSolver::Status status = soplex->solve();
@@ -425,28 +420,4 @@
   }
 
-  void SoplexLp::_messageLevel(MessageLevel level) {
-    switch (level) {
-    case MESSAGE_NOTHING:
-      _message_level = -1;
-      break;
-    case MESSAGE_ERROR:
-      _message_level = soplex::SPxOut::ERROR;
-      break;
-    case MESSAGE_WARNING:
-      _message_level = soplex::SPxOut::WARNING;
-      break;
-    case MESSAGE_NORMAL:
-      _message_level = soplex::SPxOut::INFO2;
-      break;
-    case MESSAGE_VERBOSE:
-      _message_level = soplex::SPxOut::DEBUG;
-      break;
-    }
-  }
-
-  void SoplexLp::_applyMessageLevel() {
-    soplex::Param::setVerbose(_message_level);
-  }
-
 } //namespace lemon
 
Index: lemon/soplex.h
===================================================================
--- lemon/soplex.h	(revision 623)
+++ lemon/soplex.h	(revision 587)
@@ -145,9 +145,4 @@
     virtual void _clear();
 
-    void _messageLevel(MessageLevel m);
-    void _applyMessageLevel();
-
-    int _message_level;
-
   };
 
